Package org.jfree.layouting.normalizer.displaymodel

## Interface ModelBuilder

- All Superinterfaces:
    `StatefullComponent`
  All Known Implementing Classes:
    `EmptyModelBuilder`, `FastDisplayModelBuilder`

      public interface ModelBuilder
      extends StatefullComponent

  The model builder is the second stage in the layout process. The builder receives events from the Normalizer and builds a normalized displayable logical model. Although still working on a logical document model, this model is already bound to the constraints of the underlying renderer. Each generated element has information on which logical page it will be rendered (by looking at the page style name); depending on the output target, it might even know the physical page already (including the page number). (The PageInformation is initiated by the Normalizer.) The ModelBuilder is responsible to manage the moved content.
  Author:
    Thomas Morgner

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addContent​(ContentToken content)` |
    `void` | `endDocument​()` |
    `void` | `endElement​()` |
    `Renderer` | `getRenderer​()` |
    `void` | `handlePageBreak​(PageContext pageContext)` |
    `void` | `startDocument​(PageContext pageContext)` |
    `void` | `startElement​(LayoutContext layoutContext)` |

    - ### Methods inherited from interface org.jfree.layouting.StatefullComponent

      `saveState`

- - ### Method Detail

    - #### startDocument

          void startDocument​(PageContext pageContext)
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startElement

          void startElement​(LayoutContext layoutContext)
                     throws NormalizationException,
                            java.io.IOException

      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### addContent

          void addContent​(ContentToken content)
                   throws NormalizationException

      Throws:
        `NormalizationException`

    - #### endElement

          void endElement​()
                   throws NormalizationException

      Throws:
        `NormalizationException`

    - #### endDocument

          void endDocument​()
                    throws NormalizationException

      Throws:
        `NormalizationException`

    - #### handlePageBreak

          void handlePageBreak​(PageContext pageContext)
                        throws NormalizationException

      Throws:
        `NormalizationException`

    - #### getRenderer

          Renderer getRenderer​()